unit Timestop;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs;

type
  TTimeStop = class(TComponent)
  private
  FDay, FMonth, FYear: integer;
      FMessage: string;
      FShowExpireMessage: boolean;
      FOnExpire: TNotifyEvent;
      procedure SetDay( Value: integer );
      procedure SetMonth( Value: integer );
      procedure SetYear( Value: integer );
    { Private declarations }
  protected
     procedure Loaded; override;
    { Protected declarations }
  public
     constructor Create( AOwner : TComponent ); override;
    { Public declarations }
  published
     property Day: integer read FDay write SetDay default 1;
      property Month: integer read FMonth write SetMonth default 1;
      property Year: integer read FYear write SetYear default 1996;
      property Text: string read FMessage write FMessage;
      property ShowExpireMessage: boolean read FShowExpireMessage write FShowExpireMessage;
      property OnExpire : TNotifyEvent Read FOnExpire Write FOnExpire;
    { Published declarations }
  end;

procedure Register;

implementation

constructor TTimeStop.Create( AOwner : TComponent );
begin
   inherited Create(AOwner);
   FDay := 1;
   FMonth := 1;
   FYear := 1996;
   FShowExpireMessage := true;
   FMessage := 'This version has expired. Please see readme.txt file on ' +
      'how to obtain newer version.';
end;

{-------------------------------------------------------------------------}

procedure TTimeStop.SetDay( Value: integer );
begin
   if Value in [1..31] then
      FDay := Value
   else
      ShowMessage( 'Day must be between 1 and 31 as you know.' );
end;

{-------------------------------------------------------------------------}

procedure TTimeStop.SetMonth( Value: integer );
begin
   if Value in [1..12] then
      FMonth := Value
   else
      ShowMessage( 'Month must be between 1 and 12 as you know.' );
end;

{-------------------------------------------------------------------------}

procedure TTimeStop.SetYear( Value: integer );
begin
   if ( Value > 1995 ) AND ( Value < 3000 ) then
      FYear := Value
   else
      ShowMessage( 'Year must be between 1996 and 3000.' );
end;

{-------------------------------------------------------------------------}

procedure TTimeStop.Loaded;
begin
   Inherited Loaded;
   if NOT ( csDesigning in ComponentState ) then begin
      if Date > EncodeDate( FYear, FMonth, FDay ) then begin
         if FShowExpireMessage then begin
            ShowMessage( FMessage );
         end;
         if Assigned( FOnExpire ) Then FOnExpire( Self );
         Halt;
      end;
   end;
end;

{-------------------------------------------------------------------------}
procedure Register;
begin
  RegisterComponents('Standard', [TTimeStop]);
end;

end.
